<template>
    <a-drawer
        :title="formData.id ? '编辑车辆装卸货管理表' : '增加车辆装卸货管理表'"
        :width="600"
        :visible="visible"
        :destroy-on-close="true"
        :footer-style="{ textAlign: 'right' }"
        @close="onClose"
    >
        <a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
            <a-form-item label="项目编码：" name="depotId">
                <a-select v-model:value="formData.depotId" placeholder="请选择项目编码" :options="depotIdOptions" />
            </a-form-item>
            <a-form-item label="车辆预约ID：" name="truckBookId">
                <a-input v-model:value="formData.truckBookId" placeholder="请输入车辆预约ID" allow-clear />
            </a-form-item>
            <a-form-item label="车牌：" name="licensePlate">
                <a-input v-model:value="formData.licensePlate" placeholder="请输入车牌" allow-clear />
            </a-form-item>
            <a-form-item label="司机姓名：" name="driverName">
                <a-input v-model:value="formData.driverName" placeholder="请输入司机姓名" allow-clear />
            </a-form-item>
            <a-form-item label="库位：" name="shedName">
                <a-input v-model:value="formData.shedName" placeholder="请输入库位" allow-clear />
            </a-form-item>
            <a-form-item label="一次照片时间：" name="onePicTime">
                <a-input v-model:value="formData.onePicTime" placeholder="请输入一次照片时间" allow-clear />
            </a-form-item>
            <a-form-item label="一次照片url：" name="onePicUrl">
                <a-input v-model:value="formData.onePicUrl" placeholder="请输入一次照片url" allow-clear />
            </a-form-item>
            <a-form-item label="二次照片时间：" name="twoPicTime">
                <a-input v-model:value="formData.twoPicTime" placeholder="请输入二次照片时间" allow-clear />
            </a-form-item>
            <a-form-item label="二次照片url：" name="twoPicUrl">
                <a-input v-model:value="formData.twoPicUrl" placeholder="请输入二次照片url" allow-clear />
            </a-form-item>
        </a-form>
        <template #footer>
            <a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
            <a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
        </template>
    </a-drawer>
</template>

<script setup name="depotTruckLadeForm">
    import tool from '@/utils/tool'
    import { cloneDeep } from 'lodash-es'
    import { required } from '@/utils/formRules'
    import depotTruckLadeApi from '@/api/biz/depotTruckLadeApi'
    // 抽屉状态
    const visible = ref(false)
    const emit = defineEmits({ successful: null })
    const formRef = ref()
    // 表单数据
    const formData = ref({})
    const submitLoading = ref(false)
    const depotIdOptions = ref([])

    // 打开抽屉
    const onOpen = (record) => {
        visible.value = true
        if (record) {
            let recordData = cloneDeep(record)
            formData.value = Object.assign({}, recordData)
        }
        depotIdOptions.value = tool.dictList('depotId')
    }
    // 关闭抽屉
    const onClose = () => {
        formRef.value.resetFields()
        formData.value = {}
        visible.value = false
    }
    // 默认要校验的
    const formRules = {
    }
    // 验证并提交数据
    const onSubmit = () => {
        formRef.value
            .validate()
            .then(() => {
                submitLoading.value = true
                const formDataParam = cloneDeep(formData.value)
                depotTruckLadeApi
                    .depotTruckLadeSubmitForm(formDataParam, !formDataParam.id)
                    .then(() => {
                        onClose()
                        emit('successful')
                    })
                    .finally(() => {
                        submitLoading.value = false
                    })
            })
    }
    // 抛出函数
    defineExpose({
        onOpen
    })
</script>
